import { CountUp } from 'countup.js';

document.addEventListener('DOMContentLoaded', () => {
  const countElements = document.querySelectorAll('.js-count');

  countElements.forEach((element) => {
    const countUp = new CountUp(element, element.getAttribute('data-to'), {
      duration: element.getAttribute('data-speed') || 2, // Default speed is 2 seconds
    });

    if (!countUp.error) {
      // Start the animation when the element is in the viewport
      const options = {
        root: null, // use the viewport as the root
        rootMargin: '0px', // no margin
        threshold: 0.5, // trigger when 50% of the element is visible
      };

      const observer = new IntersectionObserver((entries, observer) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            countUp.start();
            observer.unobserve(entry.target);
          }
        });
      }, options);

      observer.observe(element);
    } else {
      console.error(countUp.error);
    }
  });
});
